class MeBot expands Mutator;

var color clMsg;

event PostBeginPlay()
{
	if ( Level.Game != None )
		Level.Game.RegisterMessageMutator(Self);
}

function Mutate(string MutateString, PlayerPawn Sender)
{
	local InvWay W;
	local bool bAbusing;
	local Actor Path;
	local float BestWeight;

	if ( MutateString ~= "mebot" )
	{
		clMsg.R=100;
		clMsg.G=100;
		clMsg.B=100;
		BestWeight = 0;
		foreach Sender.ChildActors (class'InvWay',W)
		{
			if ( W != None )
			{
				bAbusing = True;
				Sender.ClientPlaySound(Sound'UnrealShare.BreakGlass');
				break;
			}
		}
		if (bAbusing)
		{
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("Mr. Bot, Your beacon has already spawned... If you don't see it wander around and retry later...",1);
			clMsg.R=255;
			clMsg.G=255;
			clMsg.B=120;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(3);
//			Sender.ClientMessage("Mr. Bot, Your beacon has already spawned... If you don't see it wander around and retry later...", 'CriticalEvent', True);
		}
		else
		{
			Path = Sender.FindBestInventoryPath(BestWeight,False);
			if ( Path != None )
			{
				if ( Teleporter(Path) != None && Sender.RouteCache[2] != None )
				{
					if (!Sender.LineOfSightTo(Sender.RouteCache[2]))
					{
						Sender.ClearProgressMessages();
						Sender.SetProgressMessage("Next isn't visible...",1);
						clMsg.R=200;
						clMsg.G=200;
						Sender.SetProgressColor(clMsg,1);
						Sender.SetProgressTime(3);
//						Sender.ClientMessage("Next isn't visible...",'CriticalStringPlus',True);
						Path = Sender.RouteCache[2];
					}
				}
				W = Spawn(class'InvWay',Sender,,Path.Location);
				if ( W != None )
				{
					W.Path = Path;
					if ( Path.Base != None )
						W.SetBase(Path.Base);
					else
						W.SetBase(None);
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Your Inventory way is shown. See the lamp and move there...",1);
					clMsg.R=0;
					clMsg.G=255;
					clMsg.B=64;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(3);
					Sender.ClientPlaySound(Sound'UnrealI.CannonShot');
//					Sender.ClientMessage( "Your Inventory way is shown. See the lamp and move there...", 'CriticalStringPlus', True );
				}
				else
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Cannot deal this time...",1);
					clMsg.R=240;
					clMsg.G=0;
					clMsg.B=0;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(3);
//					Sender.ClientMessage( "Cannot deal this time...", 'CriticalStringPlus', True );
				}
			}
			else
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Unable to find your Inventory way. Wander at walls then...",1);
					clMsg.R=250;
					clMsg.G=0;
					clMsg.B=0;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(3);
					Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
//					Sender.ClientMessage("Unable to find your Inventory way. Wander at walls then...", 'CriticalStringPlus', True);
				}
		}
	}

	if ( NextMutator != None )
		NextMutator.Mutate(MutateString, Sender);
}

DefaultProperties
{
}